Subject: Re: bug#40273: installer: No way to input Latin characters with non-Latin keyboard layouts

From: "pelzflorian (Florian Pelz)" <[email-masked]>
Date: Tue, 31 Mar 2020 18:55:59 +0200

On Tue, Mar 31, 2020 at 05:35:41PM +0200, Ludovic Courtès wrote:
> I think we can have both Alt-Shift and what Mathieu implemented, no?
> 

Yes, both would be best, what Mathieu implemented is more
discoverable.

> However, note that the installed system won’t have Alt-Shift support,
> and perhaps that is a bigger concern.

Yes.

guix build -S console-setup
sudo mkdir -p /usr/share/X11
cd /usr/share/X11
sudo ln -s /gnu/store/fabcbhjh4g5fmm39fmkjjhiplqwrg0n8-console-setup-1.194-checkout/Keyboard/ckb xkb
ckbcomp ar,fr -variant azerty, -option grp:alt_shift_toggle > ~/test
sudo loadkeys ~/test

works, but I have no idea how to turn that into a keyboard-layout.
I tried setting in /etc/config.scm

 (keyboard-layout
  (keyboard-layout "ar,fr" "azerty" #:options '("grp:alt_shift_toggle")))

but it threw an error.

> OTOH, we’re just using the standard XKB layouts, so if they don’t
> provide Alt-Shift, well, perhaps that’s because this is the way it’s got
> to be?

I did not know back then, but it does work.  In dconf-editor, I can
set org.gnome.desktop.input-sources to ['grp:alt_shift_toggle'].  It
switches between all configured layouts in GNOME.

> Is “grp:alt_shift_toggle” guaranteed to be available, no what what
> ‘layout’ is?
> 
> Also, that means Alt-Shift is enabled for all layouts, not just the
> non-Latin layouts, right?

Yes, with the patch I can toggle any layout to US layout and back.

I believe we would need a map from each layout to whether it should be
QWERTY, AZERTY, QWERTZ …  Or we would just use QWERTY.

What do you think is the right path forward?

Thank you.

Regards,
Florian